/* @(#)$Id: sb_imp.h,v 2.4 2013-02-09 06:55:20 hurtta Exp $ */

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 2.4 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@siilo.FMI.FI> 
 *                  (was hurtta+elm@posti.FMI.FI, hurtta+elm@ozone.FMI.FI)
 *      or  Kari Hurtta <elm@elmme-mailer.org>
 *****************************************************************************/

#if ANSI_C
struct pgrng_bfr_binding;
#endif

#define STRINGBUFFER_magic   0xEB0D

struct stringbuffer {
    unsigned short             magic;    /* STRINGBUFFER_magic */

    int refcount;

    struct sb_type           * buffer_type;
    union {
	void                * dummy;
	struct sb_in_file   * file;
	struct sb_in_mem    * mem;
    } a;
};

typedef int  sb_init_buffer P_((struct stringbuffer *buffer));
typedef void sb_free_buffer P_((struct stringbuffer *buffer));
typedef void sb_add_line_to_stringbuffer P_((struct stringbuffer *buffer,
					     const struct string *string,
					     int pg_flags,struct pager_range *range,
					     struct pgrng_bfr_binding  * binding));
typedef int sb_linecount_stringbuffer P_((const struct stringbuffer *ptr));
typedef struct string *sb_get_line_from_stringbuffer P_((struct stringbuffer *buffer,
							 int ptr,
							 int *pg_flags,
							 struct pager_range **range));


typedef void sb_add_pager_range_to_stringbuffer P_((struct stringbuffer 
						    * buffer,
						    struct pgrng_bfr_binding 
						    * binding,
						    struct pager_range 
						    * range));
/* Caller must call free_pager_range() */
typedef struct pager_range * sb_get_pager_range_from_stringbuffer 
    P_((struct stringbuffer * buffer, int index));

#define SB_TYPE_magic	     0xEB0E

struct sb_type {
    unsigned short                  magic;   /* SB_TYPE_magic */
    sb_init_buffer                * sb_init_it;
    sb_free_buffer                * sb_free_it;
    sb_add_line_to_stringbuffer   * sb_add_line_to_it;
    sb_linecount_stringbuffer     * sb_linecount_it;
    sb_get_line_from_stringbuffer * sb_get_line_from_it;
    sb_add_pager_range_to_stringbuffer * sb_add_pager_range_to_it;
    sb_get_pager_range_from_stringbuffer * sb_get_pager_range_from_it;
};

extern struct sb_type   sb_in_mem;
extern struct sb_type   sb_in_file;

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
